// RUN: llvm-mc -triple i386-unknown-unknown --show-encoding %s | FileCheck %s

// CHECK: clrssbsy -485498096(%edx,%eax,4) 
// CHECK: encoding: [0xf3,0x0f,0xae,0xb4,0x82,0x10,0xe3,0x0f,0xe3]         
clrssbsy -485498096(%edx,%eax,4) 

// CHECK: clrssbsy 485498096(%edx,%eax,4) 
// CHECK: encoding: [0xf3,0x0f,0xae,0xb4,0x82,0xf0,0x1c,0xf0,0x1c]         
clrssbsy 485498096(%edx,%eax,4) 

// CHECK: clrssbsy 485498096(%edx) 
// CHECK: encoding: [0xf3,0x0f,0xae,0xb2,0xf0,0x1c,0xf0,0x1c]         
clrssbsy 485498096(%edx) 

// CHECK: clrssbsy 485498096 
// CHECK: encoding: [0xf3,0x0f,0xae,0x35,0xf0,0x1c,0xf0,0x1c]         
clrssbsy 485498096 

// CHECK: clrssbsy 64(%edx,%eax) 
// CHECK: encoding: [0xf3,0x0f,0xae,0x74,0x02,0x40]         
clrssbsy 64(%edx,%eax) 

// CHECK: clrssbsy (%edx) 
// CHECK: encoding: [0xf3,0x0f,0xae,0x32]         
clrssbsy (%edx) 

// CHECK: endbr64
// CHECK: # encoding: [0xf3,0x0f,0x1e,0xfa]
endbr64

// CHECK: endbr32
// CHECK: # encoding: [0xf3,0x0f,0x1e,0xfb]
endbr32

// CHECK: incsspd %eax
// CHECK: # encoding: [0xf3,0x0f,0xae,0xe8]
incsspd %eax

// CHECK: rdsspd %eax 
// CHECK: encoding: [0xf3,0x0f,0x1e,0xc8]         
rdsspd %eax 

// CHECK: rstorssp -485498096(%edx,%eax,4) 
// CHECK: encoding: [0xf3,0x0f,0x01,0xac,0x82,0x10,0xe3,0x0f,0xe3]         
rstorssp -485498096(%edx,%eax,4) 

// CHECK: rstorssp 485498096(%edx,%eax,4) 
// CHECK: encoding: [0xf3,0x0f,0x01,0xac,0x82,0xf0,0x1c,0xf0,0x1c]         
rstorssp 485498096(%edx,%eax,4) 

// CHECK: rstorssp 485498096(%edx) 
// CHECK: encoding: [0xf3,0x0f,0x01,0xaa,0xf0,0x1c,0xf0,0x1c]         
rstorssp 485498096(%edx) 

// CHECK: rstorssp 485498096 
// CHECK: encoding: [0xf3,0x0f,0x01,0x2d,0xf0,0x1c,0xf0,0x1c]         
rstorssp 485498096 

// CHECK: rstorssp 64(%edx,%eax) 
// CHECK: encoding: [0xf3,0x0f,0x01,0x6c,0x02,0x40]         
rstorssp 64(%edx,%eax) 

// CHECK: rstorssp (%edx) 
// CHECK: encoding: [0xf3,0x0f,0x01,0x2a]         
rstorssp (%edx) 

// CHECK: saveprevssp 
// CHECK: encoding: [0xf3,0x0f,0x01,0xea]          
saveprevssp 

// CHECK: setssbsy
// CHECK: # encoding: [0xf3,0x0f,0x01,0xe8]
setssbsy

// CHECK: wrssd %eax, 3809469200(%edx,%eax,4) 
// CHECK: encoding: [0x0f,0x38,0xf6,0x84,0x82,0x10,0xe3,0x0f,0xe3]        
wrssd %eax, 3809469200(%edx,%eax,4) 

// CHECK: wrssd %eax, 485498096(%edx,%eax,4) 
// CHECK: encoding: [0x0f,0x38,0xf6,0x84,0x82,0xf0,0x1c,0xf0,0x1c]        
wrssd %eax, 485498096(%edx,%eax,4) 

// CHECK: wrssd %eax, 485498096(%edx) 
// CHECK: encoding: [0x0f,0x38,0xf6,0x82,0xf0,0x1c,0xf0,0x1c]        
wrssd %eax, 485498096(%edx) 

// CHECK: wrssd %eax, 485498096 
// CHECK: encoding: [0x0f,0x38,0xf6,0x05,0xf0,0x1c,0xf0,0x1c]        
wrssd %eax, 485498096 

// CHECK: wrssd %eax, 64(%edx,%eax) 
// CHECK: encoding: [0x0f,0x38,0xf6,0x44,0x02,0x40]        
wrssd %eax, 64(%edx,%eax) 

// CHECK: wrssd %eax, (%edx) 
// CHECK: encoding: [0x0f,0x38,0xf6,0x02]        
wrssd %eax, (%edx) 

// CHECK: wrussd %eax, 3809469200(%edx,%eax,4) 
// CHECK: encoding: [0x66,0x0f,0x38,0xf5,0x84,0x82,0x10,0xe3,0x0f,0xe3]        
wrussd %eax, 3809469200(%edx,%eax,4) 

// CHECK: wrussd %eax, 485498096(%edx,%eax,4) 
// CHECK: encoding: [0x66,0x0f,0x38,0xf5,0x84,0x82,0xf0,0x1c,0xf0,0x1c]        
wrussd %eax, 485498096(%edx,%eax,4) 

// CHECK: wrussd %eax, 485498096(%edx) 
// CHECK: encoding: [0x66,0x0f,0x38,0xf5,0x82,0xf0,0x1c,0xf0,0x1c]        
wrussd %eax, 485498096(%edx) 

// CHECK: wrussd %eax, 485498096 
// CHECK: encoding: [0x66,0x0f,0x38,0xf5,0x05,0xf0,0x1c,0xf0,0x1c]        
wrussd %eax, 485498096 

// CHECK: wrussd %eax, 64(%edx,%eax) 
// CHECK: encoding: [0x66,0x0f,0x38,0xf5,0x44,0x02,0x40]        
wrussd %eax, 64(%edx,%eax) 

// CHECK: wrussd %eax, (%edx) 
// CHECK: encoding: [0x66,0x0f,0x38,0xf5,0x02]        
wrussd %eax, (%edx) 

